SystemOrganization addCategory: #Smagick!
SystemOrganization addCategory: #'Smagick-Utils'!

!String methodsFor: '*Smagick' stamp: 'SR 6/30/2007 18:20'!
asGeometry
	^ self! !

OrderedCollection subclass: #SmagickFormats
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickFormats methodsFor: 'printing' stamp: 'SR 7/9/2007 23:38'!
printOn: aStream
	self isEmpty ifFalse: [ 
		aStream nextPutAll: '-format'; space; nextPutAll: '"'.
		self do: [ :each | each printOn: aStream ] separatedBy: [ aStream space ].
		aStream nextPutAll: '"' ]! !

Object subclass: #Smagick
	instanceVariableNames: 'flags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!Smagick class methodsFor: 'actions' stamp: 'SR 7/9/2007 13:30'!
convert: aFile to: anotherFile
	^ SmagickConvert new
		from: aFile;
		to: anotherFile;
		yourself! !

!Smagick class methodsFor: 'actions' stamp: 'SR 7/9/2007 13:42'!
identify: aFile
	^ SmagickIdentify new 
		from: aFile;
		yourself! !

!Smagick class methodsFor: 'accessing' stamp: 'SR 6/30/2007 16:08'!
tools
	^ self allSubclasses collect: [ :each | each new ]! !

!Smagick methodsFor: 'accessing' stamp: 'SR 7/10/2007 00:08'!
command
	^ String streamContents: [ :stream | stream 
		nextPutAll: (self environment commandFor: self); space;
		nextPutAll: self preOptions; space;
		nextPutAll: self options; space;
		nextPutAll: self postOptions; space ]! !

!Smagick methodsFor: 'accessing' stamp: 'SR 7/10/2007 00:07'!
environment
	^ SmagickEnvironment ! !

!Smagick methodsFor: 'actions' stamp: 'SR 7/9/2007 13:34'!
execute
	^ self execute: self command! !

!Smagick methodsFor: 'private' stamp: 'SR 7/9/2007 16:03'!
execute: aString
	^ SmagickIO  execute: self! !

!Smagick methodsFor: 'private' stamp: 'SR 7/9/2007 23:25'!
flags
	^ flags ifNil: [ flags := ReadWriteStream with: String new ]! !

!Smagick methodsFor: 'private' stamp: 'SR 7/9/2007 15:42'!
ioStream
	^ FileStream fileNamed: self ioStreamName! !

!Smagick methodsFor: 'private' stamp: 'SR 7/9/2007 23:26'!
options
	^ self flags contents! !

!Smagick methodsFor: 'private' stamp: 'SR 7/9/2007 23:53'!
parse: aStream for: aProcess
	^ self subclassResponsibility ! !

!Smagick methodsFor: 'private' stamp: 'SR 7/9/2007 13:27'!
postOptions
	^ ''! !

!Smagick methodsFor: 'private' stamp: 'SR 7/9/2007 13:27'!
preOptions
	^ ''! !

!Smagick methodsFor: 'printing' stamp: 'SR 6/30/2007 22:36'!
printOn: aStream
	aStream nextPutAll: self command! !

!Smagick methodsFor: 'private' stamp: 'SR 7/9/2007 23:54'!
put: aString
	self flags space; nextPutAll: aString! !

!Smagick methodsFor: 'private' stamp: 'SR 6/30/2007 22:04'!
put: aCommand with: aValue
	self put: aCommand with: aValue postfix: ''! !

!Smagick methodsFor: 'private' stamp: 'SR 6/30/2007 22:15'!
put: aCommand with: aValue postfix: aString
	aValue isNil not ifTrue: [ 
		self put: aCommand asString;
			put: (aValue asString, aString) ]! !

!Smagick methodsFor: 'private' stamp: 'SR 7/2/2007 13:01'!
put: aCommand with: aValue with: anotherValue
	(aValue isNil not and: [ anotherValue isNil not ]) ifTrue: [ 
		self put: aCommand asString;
			put: (aValue asString);
			put: (aValue asString) ]! !

!Smagick methodsFor: 'private' stamp: 'SR 7/9/2007 23:52'!
returned: aStream for: aProcess
	^  (aProcess isComplete and: [ aProcess succeeded ])
		ifTrue: [ self parse: aStream for: aProcess ]
		ifFalse: [ nil ]! !

Smagick subclass: #SmagickConvert
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickConvert methodsFor: 'image merging' stamp: 'SR 6/30/2007 22:10'!
adjoin
	self put: '-adjoin'! !

!SmagickConvert methodsFor: 'image merging' stamp: 'SR 6/30/2007 22:10'!
adjoinForce
	self put: '+adjoin'! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:05'!
antialias
	self put: '-antialias' ! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:05'!
authenticate: aString
	self
		put: '-authenticate' 
		with: aString! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 6/30/2007 22:05'!
autoOriented
	self put: '-auto-orient' ! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:05'!
average
	self put: '-average'! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:09'!
backdrop: aColor
	self 
		put: '-backdrop' 
		with: aColor! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:05'!
bias: aNumber percentage: aBoolean
	self 
		put: '-bias' 
		with: aNumber
		postfix: (aBoolean ifTrue: [ '%' ] ifFalse: [ '' ])! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:28'!
bilevel
	self type: SmagickConstants bilevel! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:05'!
blackPointCompensation
	self put: '-black-point-compensation' ! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 6/30/2007 22:05'!
blackThreshold: aNumber
	self
		put: '-black-threshold' 
		with: aNumber 
		postfix: '%'! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:05'!
blur: aPointOrNumber
	" aPointOrNumber = radius[0..1] @ sigma "
	self 
		put: '-blur' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:19'!
blurGaussian: aPointOrNumber
	self 
		put: '-gaussian-blur' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:05'!
blurRadial: aFloat
	self 
		put: '-radial-blur' 
		with: aFloat! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 7/2/2007 12:20'!
border: anInteger color: aColor
	self 
		put: '-bordercolor' 
		with: aColor.
	self 
		put: '-border' 
		with: anInteger.
	! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
charcoal: aNumber
	self 
		put: '-charcoal' 
		with: aNumber! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:29'!
colorSeparation
	self type: SmagickConstants colorSeparation! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:29'!
colorSeparationMatte
	self type: SmagickConstants colorSeparationMatte! !

!SmagickConvert methodsFor: 'private image operations' stamp: 'SR 7/2/2007 12:39'!
compress: aCompression
	self 
		put: '-compress' 
		with: aCompression! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:51'!
contrast: aNumber
	| selector |
	aNumber = 0 ifTrue: [ ^ self ].
	aNumber > 0 
		ifTrue: [ selector := #moreContrast ]
		ifFalse: [ selector := #lessContrast ].
	1 to: aNumber abs do: [ :i |
		self perform: selector ]! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 12:53'!
despeckle
	self put: '-despeckle' ! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 13:10'!
emboss: aFloat
	self 
		put: '-emboss' 
		with: aFloat! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:11'!
enhance
	self put: '-enhance'! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:11'!
equalize
	self put: '-equalize'! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 7/2/2007 12:23'!
flip
	self put: '-flip'! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 7/2/2007 13:16'!
flop
	self put: '-flop'! !

!SmagickConvert methodsFor: 'accessing' stamp: 'SR 7/9/2007 13:49'!
from
	^ from! !

!SmagickConvert methodsFor: 'accessing' stamp: 'SR 7/9/2007 13:49'!
from: aFile
	from := aFile! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 13:17'!
gamma: aFloat
	self 
		 put: '-gamma'
		with: aFloat! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:27'!
grayscale
	self type: SmagickConstants grayscale! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:52'!
lessContrast
	self put: '+contrast'! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:22'!
makeTransparent: aColor
	self 
		put: '-transparent'
		with: aColor! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:52'!
moreContrast
	self put: '-contrast'! !

!SmagickConvert methodsFor: 'private' stamp: 'SR 6/30/2007 16:06'!
name
	^ #convert! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:20'!
negate
	self put: '-negate' ! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:21'!
normalize
	self put: '-normalize'! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:28'!
optimizedColor
	self type: SmagickConstants optimizedColor! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 11:57'!
paint: aNumber
	self 
		put: '-paint' 
		with: aNumber! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:29'!
palette
	self type: SmagickConstants palette! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:29'!
paletteMatte
	self type: SmagickConstants paletteMatte! !

!SmagickConvert methodsFor: 'private' stamp: 'SR 7/9/2007 23:53'!
parse: aStream for: aProcess
	^ self to asString! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 13:22'!
polaroid: aNumber
	self 
		put: '-polaroid' 
		with: aNumber! !

!SmagickConvert methodsFor: 'private' stamp: 'SR 7/9/2007 13:28'!
postOptions
	^ self to asString! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 11:58'!
posterize: aNumber
	self 
		put: '-posterize' 
		with: aNumber! !

!SmagickConvert methodsFor: 'private' stamp: 'SR 7/9/2007 13:28'!
preOptions
	^ self from asString! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 12:07'!
quality: aNumber
	self 
		put: '-quality' 
		with: aNumber
		postfix: '%'! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
raise: aPoint
	self 
		put: '-raise' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 12:11'!
resample: aPoint
	self 
		put: '-resample' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 7/2/2007 13:14'!
resize: aPoint
	" resize all , keep aspects "
	self 
		put: '-resize' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'private image operations' stamp: 'SR 7/2/2007 13:13'!
resize: aPoint with: aFilter
	" resize all , keep aspects "
	self 
		put: '-filter' 
		with: aFilter.
	self 
		put: '-resize' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 21:55'!
resizeHeight: anInteger
	" resize height , keep aspects "
	self resize: (nil@anInteger)! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 21:55'!
resizeWidth: anInteger
	" resize width , keep aspects "
	self resize: (anInteger@nil)! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 6/30/2007 21:55'!
rotate: anInteger
	" 0 < anInteger < 360 "
	self rotate: anInteger postfix: ''! !

!SmagickConvert methodsFor: 'private image operations' stamp: 'SR 6/30/2007 22:03'!
rotate: anInteger postfix: aString
	self 
		put: '-rotate' 
		with: anInteger 
		postfix: aString! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 6/30/2007 21:55'!
rotateForceLandscape: anInteger
	self rotate: anInteger postfix: '>'! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 6/30/2007 21:55'!
rotateForcePortrait: anInteger
	self rotate: anInteger postfix: '<'! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:06'!
scale: aPoint
	" aPoint = x @ y "
	self 
		put: '-scale' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 6/30/2007 22:06'!
sepia: aFloat
	" 0 < aFloat < 99.9 "
	self 
		put: '-sepia-tone' 
		with: aFloat
		postfix: '%'! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:22'!
setTransparent: aColor
	self 
		put: '-transparent-color'
		with: aColor! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
shade: aPoint
	" aPoint = azimuth @ elevation "
	self 
		put: '-shade' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
shadeGray: aPoint
	" aPoint = azimuth @ elevation "
	self 
		put: '+shade' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:06'!
sharpen: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-sharpen' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:06'!
sharpenAdaptive: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-adaptive-sharpen' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 21:55'!
shave: aPoint
	" remove aPoint->x and aPoint->y pixels from all sides "
	self shave: aPoint percentage: false! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
shave: aPoint percentage: aBoolean
	self 
		put: '-shave' 
		with: aPoint asGeometry
		postfix: (aBoolean ifTrue: [ '%' ] ifFalse: [ '' ])! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:07'!
shear: aPoint
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-shear' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:07'!
sketch: aNumber
	self 
		put: '-sketch' 
		with: aNumber! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 6/30/2007 22:07'!
solarize: aFloat
	" 0 < aFloat < 99.9 "
	self 
		put: '-solarize' 
		with: aFloat
		postfix: '%'! !

!SmagickConvert methodsFor: 'image merging' stamp: 'SR 6/30/2007 22:10'!
stereo
	" create a stereo anaglyph from the image "
	self put: '-stereo'! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:07'!
strip
	" remove any proflie data or ... "
	self put: '-strip'! !

!SmagickConvert methodsFor: 'image parameters' stamp: 'SR 7/2/2007 12:16'!
stroke: aColor
	self stroke: aColor width: 1! !

!SmagickConvert methodsFor: 'image parameters' stamp: 'SR 7/2/2007 12:20'!
stroke: aColor width: aNumber
	self 
		put: '-strokewidth'
		with: aNumber.
	self 
		put: '-stroke' 
		with: aColor.
	! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:07'!
swirl: aFloat
	self 
		put: '-swirl' 
		with: aFloat! !

!SmagickConvert methodsFor: 'image settings' stamp: 'nl 7/6/2007 13:09'!
thumbnail: aPoint
	" same as resize but without image profile data "
	self 
		put: '-thumbnail' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image settings' stamp: 'nl 7/6/2007 13:09'!
thumbnailWidth: anInteger
	self thumbnail: (anInteger@nil)! !

!SmagickConvert methodsFor: 'accessing' stamp: 'SR 7/9/2007 13:24'!
to
	^ to! !

!SmagickConvert methodsFor: 'accessing' stamp: 'SR 7/9/2007 13:24'!
to: aFile
	to := aFile! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 12:23'!
transpose
	self put: '-transpose'! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:27'!
trueColor
	self type: SmagickConstants trueColor! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:28'!
trueColorMatte
	self type: SmagickConstants trueColorMatte! !

!SmagickConvert methodsFor: 'private image operations' stamp: 'SR 7/2/2007 12:24'!
type: aType
	self 
		put: '-type'
		with: aType! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 12:35'!
unsharp: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-unsharp' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 12:36'!
vignette: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-vignette' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image parameters' stamp: 'SR 7/2/2007 12:37'!
watermarkVisibility: aNumber
	self 
		put: '-watermark'
		with: aNumber
		postfix: '%'! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 12:38'!
wave: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-wave' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:38'!
whiteThreshold: aNumber
	self
		put: '-white-threshold' 
		with: aNumber 
		postfix: '%'! !

Smagick subclass: #SmagickIdentify
	instanceVariableNames: 'from formats'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickIdentify methodsFor: 'private' stamp: 'SR 7/9/2007 23:43'!
format: aSymbol with: aString value: aBlock
	self formats add: (SmagickFormat new key: aSymbol; value: aString; parser: aBlock; yourself)! !

!SmagickIdentify methodsFor: 'private' stamp: 'SR 7/9/2007 23:12'!
formats
	^ formats ifNil: [ formats := SmagickFormats new ]! !

!SmagickIdentify methodsFor: 'accessing' stamp: 'SR 7/9/2007 13:41'!
from
	^ from! !

!SmagickIdentify methodsFor: 'accessing' stamp: 'SR 7/9/2007 13:41'!
from: aFile
	from := aFile! !

!SmagickIdentify methodsFor: 'image options' stamp: 'SR 7/9/2007 23:40'!
height
	self format: #height with: '%h' value: self numberBlock! !

!SmagickIdentify methodsFor: 'private' stamp: 'SR 7/9/2007 13:40'!
name
	^ #identify! !

!SmagickIdentify methodsFor: 'private-conversion' stamp: 'SR 7/9/2007 23:41'!
numberBlock 
	^ [ :value | value asInteger ]! !

!SmagickIdentify methodsFor: 'private' stamp: 'SR 7/9/2007 23:28'!
options
	^ String streamContents: [ :stream |
		stream nextPutAll: super options; space.
		self formats printOn: stream ]! !

!SmagickIdentify methodsFor: 'private' stamp: 'SR 7/9/2007 23:54'!
parse: aStream for: aProcess
	| values tokens |
	values := Dictionary new.
	tokens := aStream asString subStrings.
	1 to: self formats size do: [ :i | |format|
		format := self formats at: i.
		values at: format key put: (format parse: (tokens at: i ifAbsent: [ nil ])) ].
	^ values! !

!SmagickIdentify methodsFor: 'private' stamp: 'SR 7/9/2007 16:18'!
postOptions
	^ self from asString! !

!SmagickIdentify methodsFor: 'private-conversion' stamp: 'SR 7/9/2007 23:41'!
stringBlock 
	^ [ :value | value asString ]! !

!SmagickIdentify methodsFor: 'accessing' stamp: 'SR 7/9/2007 16:15'!
to
	^ self from! !

!SmagickIdentify methodsFor: 'image options' stamp: 'SR 7/9/2007 13:51'!
verbose
	self put: '-verbose'! !

!SmagickIdentify methodsFor: 'image options' stamp: 'SR 7/9/2007 23:41'!
width
	self format: #width with: '%w' value: self numberBlock! !

!SmagickIdentify methodsFor: 'image options' stamp: 'SR 7/9/2007 23:20'!
widthAndHeight
	self width; height! !

!SmagickIdentify methodsFor: 'image options' stamp: 'SR 7/9/2007 23:41'!
x
	self format: #x with: '%x' value: self numberBlock! !

!SmagickIdentify methodsFor: 'image options' stamp: 'SR 7/9/2007 23:20'!
xAndY
	self x; y! !

!SmagickIdentify methodsFor: 'image options' stamp: 'SR 7/9/2007 23:41'!
y
	self format: #y with: '%y' value: self numberBlock! !

Object subclass: #SmagickConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:27'!
bilevel
	^ 'Bilevel'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
bzip
	^ 'BZip'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:41'!
colorSeparation
	^ 'ColorSeparation'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:41'!
colorSeparationMatte
	^ 'ColorSeparationMatte'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:15'!
cubic
	^ 'Cubic'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:16'!
gaussian
	^ 'Gaussian'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:26'!
grayscale
	^ 'Grayscale'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
group4
	^ 'Group4'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:15'!
hamming
	^ 'Hamming'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
jpeg
	^ 'JPEG'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
jpeg2000
	^ 'JPEG2000'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:15'!
lanczos
	^ 'Lanczos'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:44'!
lossless
	^ 'Lossless'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
lzw
	^ 'LZW'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:44'!
none
	^ 'None'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:27'!
optimizedColor
	^ 'Optimize'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:41'!
palette
	^ 'palette'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:29'!
paletteMatte
	^ 'PaletteMatte'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:15'!
quadratic
	^ 'Quadratic'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
rle
	^ 'RLE'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:27'!
trueColor
	^ 'TrueColor'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:28'!
trueColorMatte
	^ 'TrueColorMatte'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:41'!
zip
	^ 'Zip'! !

Object subclass: #SmagickEnvironment
	instanceVariableNames: ''
	classVariableNames: 'PathToImageMagick'
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickEnvironment class methodsFor: 'accessing' stamp: 'SR 7/10/2007 00:07'!
commandFor: aTool
	^ String streamContents: [ :stream |
		stream nextPutAll: self pathToImageMagick.
		self pathToImageMagick last = FileDirectory pathNameDelimiter
			ifFalse: [ stream nextPut: FileDirectory pathNameDelimiter ].
		stream nextPutAll: aTool name ]
	! !

!SmagickEnvironment class methodsFor: 'initializing' stamp: 'SR 7/9/2007 23:59'!
initialize
	super initialize.
	self isInstalled ifFalse: [ self setup ]! !

!SmagickEnvironment class methodsFor: 'testing' stamp: 'SR 7/9/2007 23:59'!
isInstalled
	^ self pathToImageMagick isNil not! !

!SmagickEnvironment class methodsFor: 'private' stamp: 'SR 7/10/2007 00:02'!
notification: aPath
	^ OBConfirmationRequest 
		prompt: '', aPath, ''' seam to be valid ... have fun !!'! !

!SmagickEnvironment class methodsFor: 'accessing' stamp: 'SR 7/10/2007 00:01'!
pathToImageMagick
	" self pathToImageMagick "
	^ PathToImageMagick! !

!SmagickEnvironment class methodsFor: 'accessing' stamp: 'SR 7/10/2007 00:01'!
pathToImageMagick: anAbsolutePath
	"e.g. /usr/local/imagemagick/bin "
	PathToImageMagick := anAbsolutePath! !

!SmagickEnvironment class methodsFor: 'private' stamp: 'SR 7/10/2007 00:02'!
requestConfirmation: aPath
	^ OBConfirmationRequest 
		prompt: '', aPath, ''' does not point to a valid ImageMagick installation. Try again ?'
		confirm: 'yes'
		cancel: 'no'! !

!SmagickEnvironment class methodsFor: 'private' stamp: 'SR 7/10/2007 00:03'!
requestText
	^ OBTextRequest 
		prompt: 'Enter the PATH to your ImageMagick installation' 
		template: '/usr/local/imagemagick/bin'! !

!SmagickEnvironment class methodsFor: 'private' stamp: 'SR 7/9/2007 23:59'!
root
	^ Smagick! !

!SmagickEnvironment class methodsFor: 'private' stamp: 'SR 7/10/2007 00:01'!
setup
	self requestText ifNotNilDo: [ :path | self setup: path ]! !

!SmagickEnvironment class methodsFor: 'private' stamp: 'SR 7/10/2007 00:01'!
setup: aPath
	(self validate: aPath)
		ifTrue: [ self pathToImageMagick: aPath. self notification: aPath ]
		ifFalse: [ (self requestConfirmation: aPath) ifTrue: [ self setup ] ]! !

!SmagickEnvironment class methodsFor: 'private' stamp: 'SR 7/10/2007 00:04'!
validate: aPath
	| directory |
	^ (directory := FileDirectory on: aPath) exists
		and: [ self root tools anySatisfy: [ :each | directory fileExists: each name ] ]! !

Object subclass: #SmagickFormat
	instanceVariableNames: 'key value parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickFormat methodsFor: 'accessing' stamp: 'SR 7/9/2007 23:43'!
key
	^key! !

!SmagickFormat methodsFor: 'accessing' stamp: 'SR 7/9/2007 23:43'!
key: aKey
	key := aKey! !

!SmagickFormat methodsFor: 'accessing' stamp: 'SR 7/9/2007 23:46'!
parse: aValue
	^ aValue ifNotNilDo: [ :val | self parser value: val ]! !

!SmagickFormat methodsFor: 'accessing' stamp: 'SR 7/9/2007 23:43'!
parser
	^ parser! !

!SmagickFormat methodsFor: 'accessing' stamp: 'SR 7/9/2007 23:44'!
parser: aBlock
	parser := aBlock! !

!SmagickFormat methodsFor: 'printing' stamp: 'SR 7/9/2007 23:37'!
printOn: aStream
	aStream nextPutAll: self value asString! !

!SmagickFormat methodsFor: 'accessing' stamp: 'SR 7/9/2007 23:43'!
value
	^ value! !

!SmagickFormat methodsFor: 'accessing' stamp: 'SR 7/9/2007 23:44'!
value: aValue
	value := aValue! !

Object subclass: #SmagickIO
	instanceVariableNames: 'transformation process stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickIO class methodsFor: 'initializing' stamp: 'SR 7/9/2007 16:10'!
execute: aTransformation
	^ self new execute: aTransformation! !

!SmagickIO methodsFor: 'private' stamp: 'SR 7/9/2007 16:26'!
execute
	[ FileStream forceNewFileNamed: self ioStreamName.
		process := OSProcess waitForCommand: self ioStreamCommand.
		stream := (FileStream fileNamed: self ioStreamName) contentsOfEntireFile ] 
	ensure: [ FileDirectory deleteFilePath: self ioStreamName ]! !

!SmagickIO methodsFor: 'public' stamp: 'SR 7/9/2007 16:10'!
execute: aTransformation
	transformation := aTransformation.
	^ self execute! !

!SmagickIO methodsFor: 'testing' stamp: 'SR 7/9/2007 16:14'!
executed
	^ self result isNil not
		and: [ self process isNil not 
			and: [ process isComplete ] ]! !

!SmagickIO methodsFor: 'private' stamp: 'SR 7/9/2007 16:19'!
ioStreamCommand
	^ self transformation command, ' > ', self ioStreamName ! !

!SmagickIO methodsFor: 'private' stamp: 'SR 7/9/2007 16:00'!
ioStreamName
	^ self transformation to, self ioStreamSuffix! !

!SmagickIO methodsFor: 'private' stamp: 'SR 7/9/2007 16:01'!
ioStreamSuffix
	^ '.smagick'! !

!SmagickIO methodsFor: 'accessing' stamp: 'SR 7/9/2007 16:08'!
process
	^ process! !

!SmagickIO methodsFor: 'accessing' stamp: 'SR 7/9/2007 16:27'!
result
	^ self transformation returned: self stream for: self process! !

!SmagickIO methodsFor: 'accessing' stamp: 'SR 7/9/2007 16:26'!
stream
	^ stream! !

!SmagickIO methodsFor: 'testing' stamp: 'SR 7/9/2007 16:13'!
succeeded
	^ self wasExecuted and: [ self process succeeded ]! !

!SmagickIO methodsFor: 'accessing' stamp: 'SR 7/9/2007 15:52'!
transformation
	^ transformation! !

!Magnitude methodsFor: '*Smagick' stamp: 'SR 6/30/2007 18:17'!
asGeometry
	^ self! !

!Point methodsFor: '*Smagick' stamp: 'SR 7/2/2007 13:02'!
asCoordinate
	^ (self x isNil not and: [ self x isNil not ])
		ifTrue: [ self x asString, ',', self x asString ]
		ifFalse: [ '' ]! !

!Point methodsFor: '*Smagick' stamp: 'SR 6/30/2007 17:44'!
asGeometry
	(self x isNil and: [ self y isNil ]) ifTrue: [ ^ '0x0' ].
	^ (self x ifNil: [ '' ]) asString, 'x', (self y ifNil: [ '' ]) asString! !

!UndefinedObject methodsFor: '*Smagick' stamp: 'SR 6/30/2007 17:43'!
@ anObject
	^ Point x: self y: anObject! !
SmagickEnvironment initialize!
